#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 243
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 46
#define ALIAS_COUNT 0
#define TOKEN_COUNT 21
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 4
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 14

enum ts_symbol_identifiers {
  anon_sym_DOT = 1,
  anon_sym_DQUOTE = 2,
  aux_sym__string_token1 = 3,
  sym_escape_sequence = 4,
  anon_sym_STAR = 5,
  anon_sym_PLUS = 6,
  anon_sym_QMARK = 7,
  sym_identifier = 8,
  aux_sym__immediate_identifier_token1 = 9,
  anon_sym__ = 10,
  anon_sym_AT = 11,
  sym_comment = 12,
  anon_sym_LBRACK = 13,
  anon_sym_RBRACK = 14,
  anon_sym_LPAREN = 15,
  anon_sym_RPAREN = 16,
  anon_sym_COLON = 17,
  anon_sym_BANG = 18,
  anon_sym_POUND = 19,
  sym_predicate_type = 20,
  sym_program = 21,
  sym__definition = 22,
  sym__group_expression = 23,
  sym__named_node_expression = 24,
  sym__string = 25,
  sym_quantifier = 26,
  sym__immediate_identifier = 27,
  sym__node_identifier = 28,
  sym_capture = 29,
  sym_string = 30,
  sym_parameters = 31,
  sym_list = 32,
  sym_grouping = 33,
  sym_anonymous_node = 34,
  sym_named_node = 35,
  sym__field_name = 36,
  sym_field_definition = 37,
  sym_negated_field = 38,
  sym_predicate = 39,
  aux_sym_program_repeat1 = 40,
  aux_sym__string_repeat1 = 41,
  aux_sym_parameters_repeat1 = 42,
  aux_sym_list_repeat1 = 43,
  aux_sym_grouping_repeat1 = 44,
  aux_sym_named_node_repeat1 = 45,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_DOT] = ".",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym__string_token1] = "_string_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_STAR] = "*",
  [anon_sym_PLUS] = "+",
  [anon_sym_QMARK] = "\?",
  [sym_identifier] = "identifier",
  [aux_sym__immediate_identifier_token1] = "identifier",
  [anon_sym__] = "_",
  [anon_sym_AT] = "@",
  [sym_comment] = "comment",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COLON] = ":",
  [anon_sym_BANG] = "!",
  [anon_sym_POUND] = "#",
  [sym_predicate_type] = "predicate_type",
  [sym_program] = "program",
  [sym__definition] = "_definition",
  [sym__group_expression] = "_group_expression",
  [sym__named_node_expression] = "_named_node_expression",
  [sym__string] = "_string",
  [sym_quantifier] = "quantifier",
  [sym__immediate_identifier] = "_immediate_identifier",
  [sym__node_identifier] = "_node_identifier",
  [sym_capture] = "capture",
  [sym_string] = "string",
  [sym_parameters] = "parameters",
  [sym_list] = "list",
  [sym_grouping] = "grouping",
  [sym_anonymous_node] = "anonymous_node",
  [sym_named_node] = "named_node",
  [sym__field_name] = "_field_name",
  [sym_field_definition] = "field_definition",
  [sym_negated_field] = "negated_field",
  [sym_predicate] = "predicate",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym__string_repeat1] = "_string_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym_grouping_repeat1] = "grouping_repeat1",
  [aux_sym_named_node_repeat1] = "named_node_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym__string_token1] = aux_sym__string_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [sym_identifier] = sym_identifier,
  [aux_sym__immediate_identifier_token1] = sym_identifier,
  [anon_sym__] = anon_sym__,
  [anon_sym_AT] = anon_sym_AT,
  [sym_comment] = sym_comment,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_POUND] = anon_sym_POUND,
  [sym_predicate_type] = sym_predicate_type,
  [sym_program] = sym_program,
  [sym__definition] = sym__definition,
  [sym__group_expression] = sym__group_expression,
  [sym__named_node_expression] = sym__named_node_expression,
  [sym__string] = sym__string,
  [sym_quantifier] = sym_quantifier,
  [sym__immediate_identifier] = sym__immediate_identifier,
  [sym__node_identifier] = sym__node_identifier,
  [sym_capture] = sym_capture,
  [sym_string] = sym_string,
  [sym_parameters] = sym_parameters,
  [sym_list] = sym_list,
  [sym_grouping] = sym_grouping,
  [sym_anonymous_node] = sym_anonymous_node,
  [sym_named_node] = sym_named_node,
  [sym__field_name] = sym__field_name,
  [sym_field_definition] = sym_field_definition,
  [sym_negated_field] = sym_negated_field,
  [sym_predicate] = sym_predicate,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym__string_repeat1] = aux_sym__string_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_list_repeat1] = aux_sym_list_repeat1,
  [aux_sym_grouping_repeat1] = aux_sym_grouping_repeat1,
  [aux_sym_named_node_repeat1] = aux_sym_named_node_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__string_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__immediate_identifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [sym_predicate_type] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__definition] = {
    .visible = false,
    .named = true,
  },
  [sym__group_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__named_node_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__node_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_capture] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_grouping] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_node] = {
    .visible = true,
    .named = true,
  },
  [sym_named_node] = {
    .visible = true,
    .named = true,
  },
  [sym__field_name] = {
    .visible = false,
    .named = true,
  },
  [sym_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_field] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_grouping_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_node_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_name = 1,
  field_parameters = 2,
  field_quantifier = 3,
  field_type = 4,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_name] = "name",
  [field_parameters] = "parameters",
  [field_quantifier] = "quantifier",
  [field_type] = "type",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 2},
  [4] = {.index = 1, .length = 2},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 5, .length = 1},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 2},
  [10] = {.index = 10, .length = 4},
  [11] = {.index = 14, .length = 2},
  [12] = {.index = 16, .length = 2},
  [13] = {.index = 18, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_name, 0},
    {field_quantifier, 1},
  [3] =
    {field_name, 1},
  [4] =
    {field_quantifier, 2},
  [5] =
    {field_quantifier, 3},
  [6] =
    {field_name, 1},
    {field_quantifier, 3},
  [8] =
    {field_name, 1},
    {field_quantifier, 4},
  [10] =
    {field_name, 1},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 3},
  [14] =
    {field_name, 1},
    {field_quantifier, 5},
  [16] =
    {field_name, 1},
    {field_quantifier, 6},
  [18] =
    {field_name, 1},
    {field_quantifier, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = sym_identifier,
  },
  [4] = {
    [0] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__string, 2,
    sym__string,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 7,
  [9] = 6,
  [10] = 10,
  [11] = 10,
  [12] = 10,
  [13] = 6,
  [14] = 7,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 15,
  [19] = 16,
  [20] = 20,
  [21] = 17,
  [22] = 20,
  [23] = 16,
  [24] = 15,
  [25] = 17,
  [26] = 20,
  [27] = 27,
  [28] = 28,
  [29] = 27,
  [30] = 30,
  [31] = 27,
  [32] = 32,
  [33] = 33,
  [34] = 32,
  [35] = 35,
  [36] = 36,
  [37] = 33,
  [38] = 36,
  [39] = 32,
  [40] = 40,
  [41] = 33,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 54,
  [56] = 54,
  [57] = 45,
  [58] = 43,
  [59] = 50,
  [60] = 49,
  [61] = 47,
  [62] = 45,
  [63] = 44,
  [64] = 53,
  [65] = 51,
  [66] = 48,
  [67] = 53,
  [68] = 48,
  [69] = 42,
  [70] = 49,
  [71] = 46,
  [72] = 47,
  [73] = 42,
  [74] = 46,
  [75] = 43,
  [76] = 51,
  [77] = 44,
  [78] = 50,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 80,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 79,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 80,
  [119] = 119,
  [120] = 117,
  [121] = 79,
  [122] = 122,
  [123] = 117,
  [124] = 96,
  [125] = 107,
  [126] = 96,
  [127] = 90,
  [128] = 97,
  [129] = 98,
  [130] = 81,
  [131] = 89,
  [132] = 111,
  [133] = 114,
  [134] = 115,
  [135] = 116,
  [136] = 113,
  [137] = 86,
  [138] = 84,
  [139] = 91,
  [140] = 103,
  [141] = 94,
  [142] = 108,
  [143] = 110,
  [144] = 85,
  [145] = 105,
  [146] = 104,
  [147] = 87,
  [148] = 88,
  [149] = 83,
  [150] = 112,
  [151] = 92,
  [152] = 93,
  [153] = 153,
  [154] = 95,
  [155] = 100,
  [156] = 101,
  [157] = 82,
  [158] = 158,
  [159] = 95,
  [160] = 106,
  [161] = 106,
  [162] = 162,
  [163] = 107,
  [164] = 112,
  [165] = 113,
  [166] = 82,
  [167] = 88,
  [168] = 87,
  [169] = 104,
  [170] = 105,
  [171] = 110,
  [172] = 108,
  [173] = 94,
  [174] = 103,
  [175] = 91,
  [176] = 84,
  [177] = 101,
  [178] = 116,
  [179] = 100,
  [180] = 115,
  [181] = 114,
  [182] = 102,
  [183] = 111,
  [184] = 81,
  [185] = 98,
  [186] = 97,
  [187] = 102,
  [188] = 83,
  [189] = 85,
  [190] = 86,
  [191] = 89,
  [192] = 90,
  [193] = 92,
  [194] = 93,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 197,
  [200] = 200,
  [201] = 196,
  [202] = 200,
  [203] = 197,
  [204] = 196,
  [205] = 200,
  [206] = 206,
  [207] = 162,
  [208] = 208,
  [209] = 209,
  [210] = 153,
  [211] = 162,
  [212] = 212,
  [213] = 153,
  [214] = 214,
  [215] = 208,
  [216] = 208,
  [217] = 206,
  [218] = 206,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 221,
  [223] = 221,
  [224] = 224,
  [225] = 225,
  [226] = 225,
  [227] = 225,
  [228] = 228,
  [229] = 229,
  [230] = 229,
  [231] = 228,
  [232] = 229,
  [233] = 228,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 235,
  [240] = 235,
  [241] = 234,
  [242] = 234,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(15);
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '"') ADVANCE(17);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '(') ADVANCE(34);
      if (lookahead == ')') ADVANCE(35);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '+') ADVANCE(25);
      if (lookahead == '.') ADVANCE(16);
      if (lookahead == ':') ADVANCE(36);
      if (lookahead == ';') ADVANCE(31);
      if (lookahead == '?') ADVANCE(26);
      if (lookahead == '@') ADVANCE(30);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == ']') ADVANCE(33);
      if (lookahead == '_') ADVANCE(29);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13)
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '"') ADVANCE(17);
      if (lookahead == '(') ADVANCE(34);
      if (lookahead == ')') ADVANCE(35);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '+') ADVANCE(25);
      if (lookahead == '.') ADVANCE(16);
      if (lookahead == ':') ADVANCE(36);
      if (lookahead == ';') ADVANCE(31);
      if (lookahead == '?') ADVANCE(26);
      if (lookahead == '@') ADVANCE(30);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == '_') ADVANCE(29);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1)
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(17);
      if (lookahead == ';') ADVANCE(18);
      if (lookahead == '\\') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(19);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == ';') ADVANCE(31);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3)
      END_STATE();
    case 4:
      if (lookahead == ';') ADVANCE(31);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4)
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 5:
      if (lookahead == 'u') ADVANCE(6);
      if (lookahead == 'x') ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(23);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 6:
      if (lookahead == '{') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 7:
      if (lookahead == '}') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(39);
      if (lookahead == ';') ADVANCE(31);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3)
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 9:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 10:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(21);
      END_STATE();
    case 11:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(7);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 13:
      if (eof) ADVANCE(15);
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '"') ADVANCE(17);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '(') ADVANCE(34);
      if (lookahead == ')') ADVANCE(35);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '+') ADVANCE(25);
      if (lookahead == '.') ADVANCE(16);
      if (lookahead == ':') ADVANCE(36);
      if (lookahead == ';') ADVANCE(31);
      if (lookahead == '?') ADVANCE(26);
      if (lookahead == '@') ADVANCE(30);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == ']') ADVANCE(33);
      if (lookahead == '_') ADVANCE(29);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13)
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 14:
      if (eof) ADVANCE(15);
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '"') ADVANCE(17);
      if (lookahead == '#') ADVANCE(38);
      if (lookahead == '(') ADVANCE(34);
      if (lookahead == ')') ADVANCE(35);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '+') ADVANCE(25);
      if (lookahead == ';') ADVANCE(31);
      if (lookahead == '?') ADVANCE(26);
      if (lookahead == '@') ADVANCE(30);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == ']') ADVANCE(33);
      if (lookahead == '_') ADVANCE(29);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14)
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(aux_sym__string_token1);
      if (lookahead == '\n') ADVANCE(20);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(18);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(aux_sym__string_token1);
      if (lookahead == ';') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(19);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(aux_sym__string_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(20);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(21);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(22);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(aux_sym__immediate_identifier_token1);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(27);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_predicate_type);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 14},
  [2] = {.lex_state = 1},
  [3] = {.lex_state = 1},
  [4] = {.lex_state = 1},
  [5] = {.lex_state = 14},
  [6] = {.lex_state = 14},
  [7] = {.lex_state = 14},
  [8] = {.lex_state = 14},
  [9] = {.lex_state = 14},
  [10] = {.lex_state = 14},
  [11] = {.lex_state = 14},
  [12] = {.lex_state = 14},
  [13] = {.lex_state = 14},
  [14] = {.lex_state = 14},
  [15] = {.lex_state = 14},
  [16] = {.lex_state = 14},
  [17] = {.lex_state = 14},
  [18] = {.lex_state = 14},
  [19] = {.lex_state = 14},
  [20] = {.lex_state = 14},
  [21] = {.lex_state = 14},
  [22] = {.lex_state = 14},
  [23] = {.lex_state = 14},
  [24] = {.lex_state = 14},
  [25] = {.lex_state = 14},
  [26] = {.lex_state = 14},
  [27] = {.lex_state = 14},
  [28] = {.lex_state = 14},
  [29] = {.lex_state = 14},
  [30] = {.lex_state = 14},
  [31] = {.lex_state = 14},
  [32] = {.lex_state = 14},
  [33] = {.lex_state = 14},
  [34] = {.lex_state = 14},
  [35] = {.lex_state = 14},
  [36] = {.lex_state = 14},
  [37] = {.lex_state = 14},
  [38] = {.lex_state = 14},
  [39] = {.lex_state = 14},
  [40] = {.lex_state = 14},
  [41] = {.lex_state = 14},
  [42] = {.lex_state = 1},
  [43] = {.lex_state = 1},
  [44] = {.lex_state = 1},
  [45] = {.lex_state = 1},
  [46] = {.lex_state = 1},
  [47] = {.lex_state = 1},
  [48] = {.lex_state = 1},
  [49] = {.lex_state = 1},
  [50] = {.lex_state = 1},
  [51] = {.lex_state = 1},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 14},
  [55] = {.lex_state = 14},
  [56] = {.lex_state = 14},
  [57] = {.lex_state = 14},
  [58] = {.lex_state = 14},
  [59] = {.lex_state = 14},
  [60] = {.lex_state = 14},
  [61] = {.lex_state = 14},
  [62] = {.lex_state = 14},
  [63] = {.lex_state = 14},
  [64] = {.lex_state = 14},
  [65] = {.lex_state = 14},
  [66] = {.lex_state = 14},
  [67] = {.lex_state = 14},
  [68] = {.lex_state = 14},
  [69] = {.lex_state = 14},
  [70] = {.lex_state = 14},
  [71] = {.lex_state = 14},
  [72] = {.lex_state = 14},
  [73] = {.lex_state = 14},
  [74] = {.lex_state = 14},
  [75] = {.lex_state = 14},
  [76] = {.lex_state = 14},
  [77] = {.lex_state = 14},
  [78] = {.lex_state = 14},
  [79] = {.lex_state = 1},
  [80] = {.lex_state = 1},
  [81] = {.lex_state = 1},
  [82] = {.lex_state = 1},
  [83] = {.lex_state = 1},
  [84] = {.lex_state = 1},
  [85] = {.lex_state = 1},
  [86] = {.lex_state = 1},
  [87] = {.lex_state = 1},
  [88] = {.lex_state = 1},
  [89] = {.lex_state = 1},
  [90] = {.lex_state = 1},
  [91] = {.lex_state = 1},
  [92] = {.lex_state = 1},
  [93] = {.lex_state = 1},
  [94] = {.lex_state = 1},
  [95] = {.lex_state = 1},
  [96] = {.lex_state = 1},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 1},
  [99] = {.lex_state = 14},
  [100] = {.lex_state = 1},
  [101] = {.lex_state = 1},
  [102] = {.lex_state = 1},
  [103] = {.lex_state = 1},
  [104] = {.lex_state = 1},
  [105] = {.lex_state = 1},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 1},
  [108] = {.lex_state = 1},
  [109] = {.lex_state = 14},
  [110] = {.lex_state = 1},
  [111] = {.lex_state = 1},
  [112] = {.lex_state = 1},
  [113] = {.lex_state = 1},
  [114] = {.lex_state = 1},
  [115] = {.lex_state = 1},
  [116] = {.lex_state = 1},
  [117] = {.lex_state = 14},
  [118] = {.lex_state = 14},
  [119] = {.lex_state = 14},
  [120] = {.lex_state = 14},
  [121] = {.lex_state = 14},
  [122] = {.lex_state = 14},
  [123] = {.lex_state = 14},
  [124] = {.lex_state = 14},
  [125] = {.lex_state = 14},
  [126] = {.lex_state = 14},
  [127] = {.lex_state = 14},
  [128] = {.lex_state = 14},
  [129] = {.lex_state = 14},
  [130] = {.lex_state = 14},
  [131] = {.lex_state = 14},
  [132] = {.lex_state = 14},
  [133] = {.lex_state = 14},
  [134] = {.lex_state = 14},
  [135] = {.lex_state = 14},
  [136] = {.lex_state = 14},
  [137] = {.lex_state = 14},
  [138] = {.lex_state = 14},
  [139] = {.lex_state = 14},
  [140] = {.lex_state = 14},
  [141] = {.lex_state = 14},
  [142] = {.lex_state = 14},
  [143] = {.lex_state = 14},
  [144] = {.lex_state = 14},
  [145] = {.lex_state = 14},
  [146] = {.lex_state = 14},
  [147] = {.lex_state = 14},
  [148] = {.lex_state = 14},
  [149] = {.lex_state = 14},
  [150] = {.lex_state = 14},
  [151] = {.lex_state = 14},
  [152] = {.lex_state = 14},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 14},
  [155] = {.lex_state = 14},
  [156] = {.lex_state = 14},
  [157] = {.lex_state = 14},
  [158] = {.lex_state = 1},
  [159] = {.lex_state = 14},
  [160] = {.lex_state = 14},
  [161] = {.lex_state = 14},
  [162] = {.lex_state = 1},
  [163] = {.lex_state = 14},
  [164] = {.lex_state = 14},
  [165] = {.lex_state = 14},
  [166] = {.lex_state = 14},
  [167] = {.lex_state = 14},
  [168] = {.lex_state = 14},
  [169] = {.lex_state = 14},
  [170] = {.lex_state = 14},
  [171] = {.lex_state = 14},
  [172] = {.lex_state = 14},
  [173] = {.lex_state = 14},
  [174] = {.lex_state = 14},
  [175] = {.lex_state = 14},
  [176] = {.lex_state = 14},
  [177] = {.lex_state = 14},
  [178] = {.lex_state = 14},
  [179] = {.lex_state = 14},
  [180] = {.lex_state = 14},
  [181] = {.lex_state = 14},
  [182] = {.lex_state = 14},
  [183] = {.lex_state = 14},
  [184] = {.lex_state = 14},
  [185] = {.lex_state = 14},
  [186] = {.lex_state = 14},
  [187] = {.lex_state = 14},
  [188] = {.lex_state = 14},
  [189] = {.lex_state = 14},
  [190] = {.lex_state = 14},
  [191] = {.lex_state = 14},
  [192] = {.lex_state = 14},
  [193] = {.lex_state = 14},
  [194] = {.lex_state = 14},
  [195] = {.lex_state = 1},
  [196] = {.lex_state = 1},
  [197] = {.lex_state = 1},
  [198] = {.lex_state = 1},
  [199] = {.lex_state = 1},
  [200] = {.lex_state = 1},
  [201] = {.lex_state = 1},
  [202] = {.lex_state = 1},
  [203] = {.lex_state = 1},
  [204] = {.lex_state = 1},
  [205] = {.lex_state = 1},
  [206] = {.lex_state = 1},
  [207] = {.lex_state = 14},
  [208] = {.lex_state = 1},
  [209] = {.lex_state = 1},
  [210] = {.lex_state = 14},
  [211] = {.lex_state = 14},
  [212] = {.lex_state = 0},
  [213] = {.lex_state = 14},
  [214] = {.lex_state = 0},
  [215] = {.lex_state = 14},
  [216] = {.lex_state = 14},
  [217] = {.lex_state = 14},
  [218] = {.lex_state = 14},
  [219] = {.lex_state = 14},
  [220] = {.lex_state = 14},
  [221] = {.lex_state = 2},
  [222] = {.lex_state = 2},
  [223] = {.lex_state = 2},
  [224] = {.lex_state = 2},
  [225] = {.lex_state = 2},
  [226] = {.lex_state = 2},
  [227] = {.lex_state = 2},
  [228] = {.lex_state = 8},
  [229] = {.lex_state = 8},
  [230] = {.lex_state = 8},
  [231] = {.lex_state = 8},
  [232] = {.lex_state = 8},
  [233] = {.lex_state = 8},
  [234] = {.lex_state = 0},
  [235] = {.lex_state = 8},
  [236] = {.lex_state = 0},
  [237] = {.lex_state = 4},
  [238] = {.lex_state = 0},
  [239] = {.lex_state = 8},
  [240] = {.lex_state = 8},
  [241] = {.lex_state = 0},
  [242] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [sym_predicate_type] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(238),
    [sym__definition] = STATE(35),
    [sym__string] = STATE(58),
    [sym_list] = STATE(35),
    [sym_grouping] = STATE(35),
    [sym_anonymous_node] = STATE(35),
    [sym_named_node] = STATE(35),
    [sym__field_name] = STATE(55),
    [sym_field_definition] = STATE(35),
    [sym_predicate] = STATE(35),
    [aux_sym_program_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym__] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_DOT,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(27), 1,
      anon_sym_RPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(13), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(202), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [48] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(31), 1,
      anon_sym_DOT,
    ACTIONS(33), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(205), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [96] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(35), 1,
      anon_sym_DOT,
    ACTIONS(37), 1,
      anon_sym_RPAREN,
    STATE(6), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(200), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [144] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_DQUOTE,
    ACTIONS(42), 1,
      sym_identifier,
    ACTIONS(45), 1,
      anon_sym__,
    ACTIONS(48), 1,
      anon_sym_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LPAREN,
    ACTIONS(54), 1,
      anon_sym_RPAREN,
    ACTIONS(56), 1,
      anon_sym_BANG,
    STATE(5), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(209), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [189] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(59), 1,
      anon_sym_RPAREN,
    STATE(5), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(196), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [234] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym__,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    ACTIONS(67), 1,
      anon_sym_POUND,
    STATE(3), 1,
      sym__node_identifier,
    STATE(31), 1,
      aux_sym_grouping_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(214), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [281] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym__,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    ACTIONS(71), 1,
      anon_sym_POUND,
    STATE(4), 1,
      sym__node_identifier,
    STATE(29), 1,
      aux_sym_grouping_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(214), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [328] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    STATE(5), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(204), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [373] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    STATE(5), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(203), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [418] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(77), 1,
      anon_sym_RPAREN,
    STATE(5), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(199), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [463] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    STATE(5), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(197), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [508] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(81), 1,
      anon_sym_RPAREN,
    STATE(5), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(201), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [553] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(61), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym__,
    ACTIONS(83), 1,
      anon_sym_RPAREN,
    ACTIONS(85), 1,
      anon_sym_POUND,
    STATE(2), 1,
      sym__node_identifier,
    STATE(27), 1,
      aux_sym_grouping_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(214), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [600] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(87), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [642] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(89), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [684] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(10), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(204), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [726] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [768] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(93), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [810] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [852] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(12), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(201), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [894] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(77), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [936] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [978] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(97), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1020] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(11), 1,
      aux_sym_named_node_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(196), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1062] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1104] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_RPAREN,
    STATE(28), 1,
      aux_sym_grouping_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(214), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [1145] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(104), 1,
      sym_identifier,
    ACTIONS(107), 1,
      anon_sym__,
    ACTIONS(110), 1,
      anon_sym_LBRACK,
    ACTIONS(113), 1,
      anon_sym_LPAREN,
    ACTIONS(116), 1,
      anon_sym_RPAREN,
    STATE(28), 1,
      aux_sym_grouping_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(214), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [1186] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(118), 1,
      anon_sym_RPAREN,
    STATE(28), 1,
      aux_sym_grouping_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(214), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [1227] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(195), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1266] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(120), 1,
      anon_sym_RPAREN,
    STATE(28), 1,
      aux_sym_grouping_repeat1,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(214), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [1307] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(124), 1,
      anon_sym__,
    ACTIONS(126), 1,
      anon_sym_LBRACK,
    ACTIONS(128), 1,
      anon_sym_RBRACK,
    ACTIONS(130), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym__field_name,
    STATE(75), 1,
      sym__string,
    STATE(36), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1345] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(124), 1,
      anon_sym__,
    ACTIONS(126), 1,
      anon_sym_LBRACK,
    ACTIONS(130), 1,
      anon_sym_LPAREN,
    ACTIONS(132), 1,
      anon_sym_RBRACK,
    STATE(54), 1,
      sym__field_name,
    STATE(75), 1,
      sym__string,
    STATE(32), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1383] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(124), 1,
      anon_sym__,
    ACTIONS(126), 1,
      anon_sym_LBRACK,
    ACTIONS(130), 1,
      anon_sym_LPAREN,
    ACTIONS(134), 1,
      anon_sym_RBRACK,
    STATE(54), 1,
      sym__field_name,
    STATE(75), 1,
      sym__string,
    STATE(36), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1421] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_DQUOTE,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym__,
    ACTIONS(13), 1,
      anon_sym_LBRACK,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(136), 1,
      ts_builtin_sym_end,
    STATE(55), 1,
      sym__field_name,
    STATE(58), 1,
      sym__string,
    STATE(38), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1459] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(138), 1,
      anon_sym_DQUOTE,
    ACTIONS(141), 1,
      sym_identifier,
    ACTIONS(144), 1,
      anon_sym__,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(150), 1,
      anon_sym_RBRACK,
    ACTIONS(152), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym__field_name,
    STATE(75), 1,
      sym__string,
    STATE(36), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1497] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(124), 1,
      anon_sym__,
    ACTIONS(126), 1,
      anon_sym_LBRACK,
    ACTIONS(130), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_RBRACK,
    STATE(54), 1,
      sym__field_name,
    STATE(75), 1,
      sym__string,
    STATE(34), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1535] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      sym_identifier,
    ACTIONS(150), 1,
      ts_builtin_sym_end,
    ACTIONS(157), 1,
      anon_sym_DQUOTE,
    ACTIONS(160), 1,
      anon_sym__,
    ACTIONS(163), 1,
      anon_sym_LBRACK,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym__field_name,
    STATE(58), 1,
      sym__string,
    STATE(38), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1573] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(124), 1,
      anon_sym__,
    ACTIONS(126), 1,
      anon_sym_LBRACK,
    ACTIONS(130), 1,
      anon_sym_LPAREN,
    ACTIONS(169), 1,
      anon_sym_RBRACK,
    STATE(54), 1,
      sym__field_name,
    STATE(75), 1,
      sym__string,
    STATE(36), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1611] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(116), 1,
      anon_sym_RPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(212), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [1649] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(124), 1,
      anon_sym__,
    ACTIONS(126), 1,
      anon_sym_LBRACK,
    ACTIONS(130), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      anon_sym_RBRACK,
    STATE(54), 1,
      sym__field_name,
    STATE(75), 1,
      sym__string,
    STATE(39), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [1687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(100), 1,
      sym_quantifier,
    STATE(95), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(173), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(175), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1718] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(107), 1,
      sym_quantifier,
    STATE(106), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(181), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(183), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1749] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(97), 1,
      sym_quantifier,
    STATE(98), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(185), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(187), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1780] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(114), 1,
      sym_quantifier,
    STATE(115), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(189), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(191), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1811] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(93), 1,
      sym_quantifier,
    STATE(92), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(193), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(195), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1842] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(84), 1,
      sym_quantifier,
    STATE(91), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(197), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(199), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(86), 1,
      sym_quantifier,
    STATE(85), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(201), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(203), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1904] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(94), 1,
      sym_quantifier,
    STATE(108), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(205), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(207), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(104), 1,
      sym_quantifier,
    STATE(87), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(209), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(211), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1966] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(113), 1,
      sym_quantifier,
    STATE(112), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(213), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(215), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [1997] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(113), 1,
      sym_quantifier,
    STATE(112), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(217), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(219), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2028] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(102), 1,
      sym_quantifier,
    STATE(96), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(177), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(221), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(223), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2059] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(124), 1,
      anon_sym__,
    ACTIONS(126), 1,
      anon_sym_LBRACK,
    ACTIONS(130), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym__field_name,
    STATE(75), 1,
      sym__string,
    STATE(217), 7,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [2093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_DQUOTE,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym__,
    ACTIONS(13), 1,
      anon_sym_LBRACK,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym__field_name,
    STATE(58), 1,
      sym__string,
    STATE(218), 7,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [2127] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym__string,
    STATE(56), 1,
      sym__field_name,
    STATE(206), 7,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [2161] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(181), 1,
      sym_quantifier,
    ACTIONS(189), 2,
      sym_identifier,
      anon_sym__,
    STATE(180), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(191), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2190] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(125), 1,
      sym_quantifier,
    ACTIONS(181), 2,
      sym_identifier,
      anon_sym__,
    STATE(160), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(183), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2219] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(146), 1,
      sym_quantifier,
    ACTIONS(209), 2,
      sym_identifier,
      anon_sym__,
    STATE(147), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(211), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2248] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(141), 1,
      sym_quantifier,
    ACTIONS(205), 2,
      sym_identifier,
      anon_sym__,
    STATE(142), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(207), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(138), 1,
      sym_quantifier,
    ACTIONS(197), 2,
      sym_identifier,
      anon_sym__,
    STATE(139), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(199), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2306] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(133), 1,
      sym_quantifier,
    ACTIONS(189), 2,
      sym_identifier,
      anon_sym__,
    STATE(134), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(191), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2335] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(128), 1,
      sym_quantifier,
    ACTIONS(185), 2,
      sym_identifier,
      anon_sym__,
    STATE(129), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(187), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2364] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(182), 1,
      sym_quantifier,
    ACTIONS(221), 2,
      sym_identifier,
      anon_sym__,
    STATE(126), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(223), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(136), 1,
      sym_quantifier,
    ACTIONS(213), 2,
      sym_identifier,
      anon_sym__,
    STATE(150), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(215), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2422] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(137), 1,
      sym_quantifier,
    ACTIONS(201), 2,
      sym_identifier,
      anon_sym__,
    STATE(144), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(203), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2451] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(187), 1,
      sym_quantifier,
    ACTIONS(221), 2,
      sym_identifier,
      anon_sym__,
    STATE(124), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(223), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2480] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(190), 1,
      sym_quantifier,
    ACTIONS(201), 2,
      sym_identifier,
      anon_sym__,
    STATE(189), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(203), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(179), 1,
      sym_quantifier,
    ACTIONS(173), 2,
      sym_identifier,
      anon_sym__,
    STATE(159), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(175), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(173), 1,
      sym_quantifier,
    ACTIONS(205), 2,
      sym_identifier,
      anon_sym__,
    STATE(172), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(207), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(152), 1,
      sym_quantifier,
    ACTIONS(193), 2,
      sym_identifier,
      anon_sym__,
    STATE(151), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(195), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2596] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(176), 1,
      sym_quantifier,
    ACTIONS(197), 2,
      sym_identifier,
      anon_sym__,
    STATE(175), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(199), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2625] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(155), 1,
      sym_quantifier,
    ACTIONS(173), 2,
      sym_identifier,
      anon_sym__,
    STATE(154), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(175), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2654] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(194), 1,
      sym_quantifier,
    ACTIONS(193), 2,
      sym_identifier,
      anon_sym__,
    STATE(193), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(195), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2683] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(163), 1,
      sym_quantifier,
    ACTIONS(181), 2,
      sym_identifier,
      anon_sym__,
    STATE(161), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(183), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2712] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(165), 1,
      sym_quantifier,
    ACTIONS(213), 2,
      sym_identifier,
      anon_sym__,
    STATE(164), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(215), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [2741] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(186), 1,
      sym_quantifier,
    ACTIONS(185), 2,
      sym_identifier,
      anon_sym__,
    STATE(185), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(187), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2770] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    STATE(169), 1,
      sym_quantifier,
    ACTIONS(209), 2,
      sym_identifier,
      anon_sym__,
    STATE(168), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(211), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [2799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(235), 9,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(239), 9,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2839] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(241), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(243), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(245), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(247), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(249), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(251), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(110), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(253), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(255), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(257), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(259), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(81), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(261), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(263), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(265), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(267), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(269), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(271), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(273), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(275), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(277), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(279), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(205), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(207), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(185), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(187), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(83), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(281), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(283), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(105), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(287), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(201), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(203), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(189), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(191), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(116), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(291), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(293), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(295), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(239), 9,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(89), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(297), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(299), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(305), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(301), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(303), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(111), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(308), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(310), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(312), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(314), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3364] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(88), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(316), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(318), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(320), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(322), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(324), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(326), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(90), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(328), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(330), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(209), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(211), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(235), 9,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(332), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(334), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(336), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(338), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(340), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(342), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(82), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(344), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(346), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(103), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(348), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(350), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(197), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(199), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 1,
      anon_sym_AT,
    STATE(101), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(352), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(354), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3659] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(220), 1,
      sym__string,
    STATE(234), 1,
      sym_parameters,
    ACTIONS(356), 2,
      sym_identifier,
      anon_sym__,
    STATE(119), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [3685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(239), 8,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3703] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(360), 1,
      anon_sym_RPAREN,
    STATE(220), 1,
      sym__string,
    ACTIONS(358), 2,
      sym_identifier,
      anon_sym__,
    STATE(122), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [3729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(220), 1,
      sym__string,
    STATE(242), 1,
      sym_parameters,
    ACTIONS(356), 2,
      sym_identifier,
      anon_sym__,
    STATE(119), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [3755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(235), 8,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3773] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_DQUOTE,
    ACTIONS(368), 1,
      anon_sym_AT,
    ACTIONS(371), 1,
      anon_sym_RPAREN,
    STATE(220), 1,
      sym__string,
    ACTIONS(365), 2,
      sym_identifier,
      anon_sym__,
    STATE(122), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [3799] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(122), 1,
      anon_sym_DQUOTE,
    ACTIONS(231), 1,
      anon_sym_AT,
    STATE(220), 1,
      sym__string,
    STATE(241), 1,
      sym_parameters,
    ACTIONS(356), 2,
      sym_identifier,
      anon_sym__,
    STATE(119), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [3825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(189), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(191), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(328), 2,
      sym_identifier,
      anon_sym__,
    STATE(192), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(330), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(189), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(191), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(277), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(279), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(289), 2,
      sym_identifier,
      anon_sym__,
    STATE(135), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(291), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(293), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(295), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(241), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(243), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(273), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(275), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(336), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(338), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(348), 2,
      sym_identifier,
      anon_sym__,
    STATE(140), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(350), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(197), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(199), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(352), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(354), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(344), 2,
      sym_identifier,
      anon_sym__,
    STATE(166), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(346), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(261), 2,
      sym_identifier,
      anon_sym__,
    STATE(130), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(263), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(253), 2,
      sym_identifier,
      anon_sym__,
    STATE(143), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(255), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(205), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(207), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(312), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(314), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(285), 2,
      sym_identifier,
      anon_sym__,
    STATE(145), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(287), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(209), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(211), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4224] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(332), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(334), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(257), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(259), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(320), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(322), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(316), 2,
      sym_identifier,
      anon_sym__,
    STATE(148), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(318), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(265), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(267), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(269), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(271), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(249), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(251), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(340), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(342), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(185), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(187), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(281), 2,
      sym_identifier,
      anon_sym__,
    STATE(149), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(283), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(373), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(375), 6,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(201), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(203), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4472] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(297), 2,
      sym_identifier,
      anon_sym__,
    STATE(131), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(299), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(377), 1,
      anon_sym_AT,
    ACTIONS(301), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(303), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(245), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(247), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_COLON,
    ACTIONS(217), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(219), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(201), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(203), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(324), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(326), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4596] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(324), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(326), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(382), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(384), 6,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(328), 2,
      sym_identifier,
      anon_sym__,
    STATE(127), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(330), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(340), 2,
      sym_identifier,
      anon_sym__,
    STATE(156), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(342), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(344), 2,
      sym_identifier,
      anon_sym__,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(346), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(245), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(247), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4718] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(269), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(271), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(265), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(267), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4760] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(316), 2,
      sym_identifier,
      anon_sym__,
    STATE(167), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(318), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(320), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(322), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(332), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(334), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(209), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(211), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(285), 2,
      sym_identifier,
      anon_sym__,
    STATE(170), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(287), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(312), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(314), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(205), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(207), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(253), 2,
      sym_identifier,
      anon_sym__,
    STATE(171), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(255), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(386), 1,
      anon_sym_AT,
    ACTIONS(301), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(303), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(352), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(354), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(297), 2,
      sym_identifier,
      anon_sym__,
    STATE(191), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(299), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [4991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(197), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(199), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(348), 2,
      sym_identifier,
      anon_sym__,
    STATE(174), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(350), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      anon_sym_AT,
    ACTIONS(308), 2,
      sym_identifier,
      anon_sym__,
    STATE(132), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(310), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(336), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(338), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(241), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(243), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(293), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(295), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(289), 2,
      sym_identifier,
      anon_sym__,
    STATE(178), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(291), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(308), 2,
      sym_identifier,
      anon_sym__,
    STATE(183), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(310), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(249), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(251), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(257), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(259), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(261), 2,
      sym_identifier,
      anon_sym__,
    STATE(184), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(263), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(273), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(275), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(277), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(279), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(185), 2,
      sym_identifier,
      anon_sym__,
    STATE(177), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(187), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_AT,
    ACTIONS(281), 2,
      sym_identifier,
      anon_sym__,
    STATE(188), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(283), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(389), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(391), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(401), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(403), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(407), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(409), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(411), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(413), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(417), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(421), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(382), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(384), 6,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(423), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(425), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_DOT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(373), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(375), 5,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(382), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(384), 5,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(431), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(373), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(375), 5,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(433), 1,
      anon_sym_DOT,
    ACTIONS(437), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(435), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(423), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(425), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(423), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(425), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(421), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(421), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(441), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(439), 3,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(443), 3,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_RPAREN,
  [5725] = 4,
    ACTIONS(447), 1,
      anon_sym_DQUOTE,
    ACTIONS(451), 1,
      sym_comment,
    STATE(227), 1,
      aux_sym__string_repeat1,
    ACTIONS(449), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [5739] = 4,
    ACTIONS(451), 1,
      sym_comment,
    ACTIONS(453), 1,
      anon_sym_DQUOTE,
    STATE(225), 1,
      aux_sym__string_repeat1,
    ACTIONS(455), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [5753] = 4,
    ACTIONS(451), 1,
      sym_comment,
    ACTIONS(457), 1,
      anon_sym_DQUOTE,
    STATE(226), 1,
      aux_sym__string_repeat1,
    ACTIONS(459), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [5767] = 4,
    ACTIONS(451), 1,
      sym_comment,
    ACTIONS(461), 1,
      anon_sym_DQUOTE,
    STATE(224), 1,
      aux_sym__string_repeat1,
    ACTIONS(463), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [5781] = 4,
    ACTIONS(451), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_DQUOTE,
    STATE(224), 1,
      aux_sym__string_repeat1,
    ACTIONS(468), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [5795] = 4,
    ACTIONS(451), 1,
      sym_comment,
    ACTIONS(470), 1,
      anon_sym_DQUOTE,
    STATE(224), 1,
      aux_sym__string_repeat1,
    ACTIONS(468), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [5809] = 4,
    ACTIONS(451), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_DQUOTE,
    STATE(224), 1,
      aux_sym__string_repeat1,
    ACTIONS(468), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [5823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 1,
      aux_sym__immediate_identifier_token1,
    STATE(162), 1,
      sym__immediate_identifier,
  [5833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(476), 1,
      aux_sym__immediate_identifier_token1,
    STATE(235), 1,
      sym__immediate_identifier,
  [5843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(478), 1,
      aux_sym__immediate_identifier_token1,
    STATE(240), 1,
      sym__immediate_identifier,
  [5853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      aux_sym__immediate_identifier_token1,
    STATE(211), 1,
      sym__immediate_identifier,
  [5863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      aux_sym__immediate_identifier_token1,
    STATE(239), 1,
      sym__immediate_identifier,
  [5873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      aux_sym__immediate_identifier_token1,
    STATE(207), 1,
      sym__immediate_identifier,
  [5883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
  [5890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(488), 1,
      sym_predicate_type,
  [5897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_COLON,
  [5904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(490), 1,
      sym_identifier,
  [5911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      ts_builtin_sym_end,
  [5918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      sym_predicate_type,
  [5925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 1,
      sym_predicate_type,
  [5932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_RPAREN,
  [5939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(500), 1,
      anon_sym_RPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 48,
  [SMALL_STATE(4)] = 96,
  [SMALL_STATE(5)] = 144,
  [SMALL_STATE(6)] = 189,
  [SMALL_STATE(7)] = 234,
  [SMALL_STATE(8)] = 281,
  [SMALL_STATE(9)] = 328,
  [SMALL_STATE(10)] = 373,
  [SMALL_STATE(11)] = 418,
  [SMALL_STATE(12)] = 463,
  [SMALL_STATE(13)] = 508,
  [SMALL_STATE(14)] = 553,
  [SMALL_STATE(15)] = 600,
  [SMALL_STATE(16)] = 642,
  [SMALL_STATE(17)] = 684,
  [SMALL_STATE(18)] = 726,
  [SMALL_STATE(19)] = 768,
  [SMALL_STATE(20)] = 810,
  [SMALL_STATE(21)] = 852,
  [SMALL_STATE(22)] = 894,
  [SMALL_STATE(23)] = 936,
  [SMALL_STATE(24)] = 978,
  [SMALL_STATE(25)] = 1020,
  [SMALL_STATE(26)] = 1062,
  [SMALL_STATE(27)] = 1104,
  [SMALL_STATE(28)] = 1145,
  [SMALL_STATE(29)] = 1186,
  [SMALL_STATE(30)] = 1227,
  [SMALL_STATE(31)] = 1266,
  [SMALL_STATE(32)] = 1307,
  [SMALL_STATE(33)] = 1345,
  [SMALL_STATE(34)] = 1383,
  [SMALL_STATE(35)] = 1421,
  [SMALL_STATE(36)] = 1459,
  [SMALL_STATE(37)] = 1497,
  [SMALL_STATE(38)] = 1535,
  [SMALL_STATE(39)] = 1573,
  [SMALL_STATE(40)] = 1611,
  [SMALL_STATE(41)] = 1649,
  [SMALL_STATE(42)] = 1687,
  [SMALL_STATE(43)] = 1718,
  [SMALL_STATE(44)] = 1749,
  [SMALL_STATE(45)] = 1780,
  [SMALL_STATE(46)] = 1811,
  [SMALL_STATE(47)] = 1842,
  [SMALL_STATE(48)] = 1873,
  [SMALL_STATE(49)] = 1904,
  [SMALL_STATE(50)] = 1935,
  [SMALL_STATE(51)] = 1966,
  [SMALL_STATE(52)] = 1997,
  [SMALL_STATE(53)] = 2028,
  [SMALL_STATE(54)] = 2059,
  [SMALL_STATE(55)] = 2093,
  [SMALL_STATE(56)] = 2127,
  [SMALL_STATE(57)] = 2161,
  [SMALL_STATE(58)] = 2190,
  [SMALL_STATE(59)] = 2219,
  [SMALL_STATE(60)] = 2248,
  [SMALL_STATE(61)] = 2277,
  [SMALL_STATE(62)] = 2306,
  [SMALL_STATE(63)] = 2335,
  [SMALL_STATE(64)] = 2364,
  [SMALL_STATE(65)] = 2393,
  [SMALL_STATE(66)] = 2422,
  [SMALL_STATE(67)] = 2451,
  [SMALL_STATE(68)] = 2480,
  [SMALL_STATE(69)] = 2509,
  [SMALL_STATE(70)] = 2538,
  [SMALL_STATE(71)] = 2567,
  [SMALL_STATE(72)] = 2596,
  [SMALL_STATE(73)] = 2625,
  [SMALL_STATE(74)] = 2654,
  [SMALL_STATE(75)] = 2683,
  [SMALL_STATE(76)] = 2712,
  [SMALL_STATE(77)] = 2741,
  [SMALL_STATE(78)] = 2770,
  [SMALL_STATE(79)] = 2799,
  [SMALL_STATE(80)] = 2819,
  [SMALL_STATE(81)] = 2839,
  [SMALL_STATE(82)] = 2862,
  [SMALL_STATE(83)] = 2885,
  [SMALL_STATE(84)] = 2908,
  [SMALL_STATE(85)] = 2931,
  [SMALL_STATE(86)] = 2954,
  [SMALL_STATE(87)] = 2977,
  [SMALL_STATE(88)] = 3000,
  [SMALL_STATE(89)] = 3023,
  [SMALL_STATE(90)] = 3046,
  [SMALL_STATE(91)] = 3069,
  [SMALL_STATE(92)] = 3092,
  [SMALL_STATE(93)] = 3115,
  [SMALL_STATE(94)] = 3138,
  [SMALL_STATE(95)] = 3161,
  [SMALL_STATE(96)] = 3184,
  [SMALL_STATE(97)] = 3207,
  [SMALL_STATE(98)] = 3230,
  [SMALL_STATE(99)] = 3253,
  [SMALL_STATE(100)] = 3272,
  [SMALL_STATE(101)] = 3295,
  [SMALL_STATE(102)] = 3318,
  [SMALL_STATE(103)] = 3341,
  [SMALL_STATE(104)] = 3364,
  [SMALL_STATE(105)] = 3387,
  [SMALL_STATE(106)] = 3410,
  [SMALL_STATE(107)] = 3433,
  [SMALL_STATE(108)] = 3456,
  [SMALL_STATE(109)] = 3479,
  [SMALL_STATE(110)] = 3498,
  [SMALL_STATE(111)] = 3521,
  [SMALL_STATE(112)] = 3544,
  [SMALL_STATE(113)] = 3567,
  [SMALL_STATE(114)] = 3590,
  [SMALL_STATE(115)] = 3613,
  [SMALL_STATE(116)] = 3636,
  [SMALL_STATE(117)] = 3659,
  [SMALL_STATE(118)] = 3685,
  [SMALL_STATE(119)] = 3703,
  [SMALL_STATE(120)] = 3729,
  [SMALL_STATE(121)] = 3755,
  [SMALL_STATE(122)] = 3773,
  [SMALL_STATE(123)] = 3799,
  [SMALL_STATE(124)] = 3825,
  [SMALL_STATE(125)] = 3846,
  [SMALL_STATE(126)] = 3867,
  [SMALL_STATE(127)] = 3888,
  [SMALL_STATE(128)] = 3909,
  [SMALL_STATE(129)] = 3930,
  [SMALL_STATE(130)] = 3951,
  [SMALL_STATE(131)] = 3972,
  [SMALL_STATE(132)] = 3993,
  [SMALL_STATE(133)] = 4014,
  [SMALL_STATE(134)] = 4035,
  [SMALL_STATE(135)] = 4056,
  [SMALL_STATE(136)] = 4077,
  [SMALL_STATE(137)] = 4098,
  [SMALL_STATE(138)] = 4119,
  [SMALL_STATE(139)] = 4140,
  [SMALL_STATE(140)] = 4161,
  [SMALL_STATE(141)] = 4182,
  [SMALL_STATE(142)] = 4203,
  [SMALL_STATE(143)] = 4224,
  [SMALL_STATE(144)] = 4245,
  [SMALL_STATE(145)] = 4266,
  [SMALL_STATE(146)] = 4287,
  [SMALL_STATE(147)] = 4308,
  [SMALL_STATE(148)] = 4329,
  [SMALL_STATE(149)] = 4350,
  [SMALL_STATE(150)] = 4371,
  [SMALL_STATE(151)] = 4392,
  [SMALL_STATE(152)] = 4413,
  [SMALL_STATE(153)] = 4434,
  [SMALL_STATE(154)] = 4451,
  [SMALL_STATE(155)] = 4472,
  [SMALL_STATE(156)] = 4493,
  [SMALL_STATE(157)] = 4514,
  [SMALL_STATE(158)] = 4535,
  [SMALL_STATE(159)] = 4554,
  [SMALL_STATE(160)] = 4575,
  [SMALL_STATE(161)] = 4596,
  [SMALL_STATE(162)] = 4617,
  [SMALL_STATE(163)] = 4634,
  [SMALL_STATE(164)] = 4655,
  [SMALL_STATE(165)] = 4676,
  [SMALL_STATE(166)] = 4697,
  [SMALL_STATE(167)] = 4718,
  [SMALL_STATE(168)] = 4739,
  [SMALL_STATE(169)] = 4760,
  [SMALL_STATE(170)] = 4781,
  [SMALL_STATE(171)] = 4802,
  [SMALL_STATE(172)] = 4823,
  [SMALL_STATE(173)] = 4844,
  [SMALL_STATE(174)] = 4865,
  [SMALL_STATE(175)] = 4886,
  [SMALL_STATE(176)] = 4907,
  [SMALL_STATE(177)] = 4928,
  [SMALL_STATE(178)] = 4949,
  [SMALL_STATE(179)] = 4970,
  [SMALL_STATE(180)] = 4991,
  [SMALL_STATE(181)] = 5012,
  [SMALL_STATE(182)] = 5033,
  [SMALL_STATE(183)] = 5054,
  [SMALL_STATE(184)] = 5075,
  [SMALL_STATE(185)] = 5096,
  [SMALL_STATE(186)] = 5117,
  [SMALL_STATE(187)] = 5138,
  [SMALL_STATE(188)] = 5159,
  [SMALL_STATE(189)] = 5180,
  [SMALL_STATE(190)] = 5201,
  [SMALL_STATE(191)] = 5222,
  [SMALL_STATE(192)] = 5243,
  [SMALL_STATE(193)] = 5264,
  [SMALL_STATE(194)] = 5285,
  [SMALL_STATE(195)] = 5306,
  [SMALL_STATE(196)] = 5322,
  [SMALL_STATE(197)] = 5340,
  [SMALL_STATE(198)] = 5358,
  [SMALL_STATE(199)] = 5374,
  [SMALL_STATE(200)] = 5392,
  [SMALL_STATE(201)] = 5410,
  [SMALL_STATE(202)] = 5428,
  [SMALL_STATE(203)] = 5446,
  [SMALL_STATE(204)] = 5464,
  [SMALL_STATE(205)] = 5482,
  [SMALL_STATE(206)] = 5500,
  [SMALL_STATE(207)] = 5516,
  [SMALL_STATE(208)] = 5532,
  [SMALL_STATE(209)] = 5548,
  [SMALL_STATE(210)] = 5566,
  [SMALL_STATE(211)] = 5581,
  [SMALL_STATE(212)] = 5596,
  [SMALL_STATE(213)] = 5611,
  [SMALL_STATE(214)] = 5626,
  [SMALL_STATE(215)] = 5643,
  [SMALL_STATE(216)] = 5657,
  [SMALL_STATE(217)] = 5671,
  [SMALL_STATE(218)] = 5685,
  [SMALL_STATE(219)] = 5699,
  [SMALL_STATE(220)] = 5712,
  [SMALL_STATE(221)] = 5725,
  [SMALL_STATE(222)] = 5739,
  [SMALL_STATE(223)] = 5753,
  [SMALL_STATE(224)] = 5767,
  [SMALL_STATE(225)] = 5781,
  [SMALL_STATE(226)] = 5795,
  [SMALL_STATE(227)] = 5809,
  [SMALL_STATE(228)] = 5823,
  [SMALL_STATE(229)] = 5833,
  [SMALL_STATE(230)] = 5843,
  [SMALL_STATE(231)] = 5853,
  [SMALL_STATE(232)] = 5863,
  [SMALL_STATE(233)] = 5873,
  [SMALL_STATE(234)] = 5883,
  [SMALL_STATE(235)] = 5890,
  [SMALL_STATE(236)] = 5897,
  [SMALL_STATE(237)] = 5904,
  [SMALL_STATE(238)] = 5911,
  [SMALL_STATE(239)] = 5918,
  [SMALL_STATE(240)] = 5925,
  [SMALL_STATE(241)] = 5932,
  [SMALL_STATE(242)] = 5939,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [39] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2), SHIFT_REPEAT(222),
  [42] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_named_node_repeat1, 2), SHIFT_REPEAT(236),
  [45] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_named_node_repeat1, 2), SHIFT_REPEAT(51),
  [48] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2), SHIFT_REPEAT(33),
  [51] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2), SHIFT_REPEAT(14),
  [54] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2),
  [56] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2), SHIFT_REPEAT(237),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 2), SHIFT_REPEAT(222),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grouping_repeat1, 2), SHIFT_REPEAT(236),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grouping_repeat1, 2), SHIFT_REPEAT(51),
  [110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 2), SHIFT_REPEAT(33),
  [113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 2), SHIFT_REPEAT(14),
  [116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 2),
  [118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(221),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(236),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(76),
  [147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(41),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(223),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(65),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 1, .production_id = 2),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 1, .production_id = 2),
  [185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 3),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 3),
  [189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 4, .production_id = 5),
  [191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 4, .production_id = 5),
  [193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 2),
  [195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 2),
  [197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 5, .production_id = 5),
  [199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 5, .production_id = 5),
  [201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 6, .production_id = 5),
  [207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 6, .production_id = 5),
  [209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, .production_id = 5),
  [211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, .production_id = 5),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 1, .production_id = 1),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 1, .production_id = 1),
  [217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__node_identifier, 1),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__node_identifier, 1),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 3, .production_id = 5),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 3, .production_id = 5),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 3),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 3),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 2),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 2),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 5, .production_id = 7),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 5, .production_id = 7),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 3, .production_id = 3),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 3, .production_id = 3),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 4, .production_id = 6),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 4, .production_id = 6),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 6, .production_id = 11),
  [255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 6, .production_id = 11),
  [257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4, .production_id = 7),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4, .production_id = 7),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, .production_id = 5),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, .production_id = 5),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 9, .production_id = 13),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 9, .production_id = 13),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4, .production_id = 6),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4, .production_id = 6),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 3, .production_id = 4),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 3, .production_id = 4),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 3, .production_id = 6),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 3, .production_id = 6),
  [285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, .production_id = 12),
  [287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, .production_id = 12),
  [289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 4, .production_id = 7),
  [291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 4, .production_id = 7),
  [293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 4),
  [295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 4),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, .production_id = 6),
  [299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, .production_id = 6),
  [301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2),
  [305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(228),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 4, .production_id = 8),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 4, .production_id = 8),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 6, .production_id = 9),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 6, .production_id = 9),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, .production_id = 13),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, .production_id = 13),
  [320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, .production_id = 12),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, .production_id = 12),
  [324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 2, .production_id = 2),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 2, .production_id = 2),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 2, .production_id = 4),
  [330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 2, .production_id = 4),
  [332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, .production_id = 11),
  [334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, .production_id = 11),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 5, .production_id = 8),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 5, .production_id = 8),
  [340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 2, .production_id = 1),
  [342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 2, .production_id = 1),
  [344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 2, .production_id = 3),
  [346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 2, .production_id = 3),
  [348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 5, .production_id = 9),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 5, .production_id = 9),
  [352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 5, .production_id = 7),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 5, .production_id = 7),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 1),
  [362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(221),
  [365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(122),
  [368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(233),
  [371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2),
  [373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantifier, 1),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantifier, 1),
  [377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(233),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_capture, 2, .production_id = 5),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_capture, 2, .production_id = 5),
  [386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(231),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_node_expression, 3),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_node_expression, 3),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 1),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_named_node_repeat1, 1),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_field, 2),
  [403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_field, 2),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_definition, 2, .production_id = 1),
  [421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_definition, 2, .production_id = 1),
  [423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate, 6, .production_id = 10),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate, 6, .production_id = 10),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__group_expression, 3),
  [431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__group_expression, 3),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 1),
  [437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_grouping_repeat1, 1),
  [439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_name, 2),
  [441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_name, 2),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1),
  [445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_repeat1, 2),
  [463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_repeat1, 2), SHIFT_REPEAT(224),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [492] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_query() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
